diff --git a/src/common/wchar.c b/src/common/wchar.c
index eb15ee59497..7fab5d262be 100644
--- a/src/common/wchar.c
+++ b/src/common/wchar.c
@@ -682,178 +682,6 @@ pg_utf_dsplen(const unsigned char *s)
 	return ucs_wcwidth(utf8_to_unicode(s));
 }
 
-/*
- * convert mule internal code to pg_wchar
- * caller should allocate enough space for "to"
- * len: length of from.
- * "from" not necessarily null terminated.
- */
-static int
-pg_mule2wchar_with_len(const unsigned char *from, pg_wchar *to, int len)
-{
-	int			cnt = 0;
-
-	while (len > 0 && *from)
-	{
-		if (IS_LC1(*from))
-		{
-			MB2CHAR_NEED_AT_LEAST(len, 2);
-			*to = *from++ << 16;
-			*to |= *from++;
-			len -= 2;
-		}
-		else if (IS_LCPRV1(*from))
-		{
-			MB2CHAR_NEED_AT_LEAST(len, 3);
-			from++;
-			*to = *from++ << 16;
-			*to |= *from++;
-			len -= 3;
-		}
-		else if (IS_LC2(*from))
-		{
-			MB2CHAR_NEED_AT_LEAST(len, 3);
-			*to = *from++ << 16;
-			*to |= *from++ << 8;
-			*to |= *from++;
-			len -= 3;
-		}
-		else if (IS_LCPRV2(*from))
-		{
-			MB2CHAR_NEED_AT_LEAST(len, 4);
-			from++;
-			*to = *from++ << 16;
-			*to |= *from++ << 8;
-			*to |= *from++;
-			len -= 4;
-		}
-		else
-		{						/* assume ASCII */
-			*to = (unsigned char) *from++;
-			len--;
-		}
-		to++;
-		cnt++;
-	}
-	*to = 0;
-	return cnt;
-}
-
-/*
- * convert pg_wchar to mule internal code
- * caller should allocate enough space for "to"
- * len: length of from.
- * "from" not necessarily null terminated.
- */
-static int
-pg_wchar2mule_with_len(const pg_wchar *from, unsigned char *to, int len)
-{
-	int			cnt = 0;
-
-	while (len > 0 && *from)
-	{
-		unsigned char lb;
-
-		lb = (*from >> 16) & 0xff;
-		if (IS_LC1(lb))
-		{
-			*to++ = lb;
-			*to++ = *from & 0xff;
-			cnt += 2;
-		}
-		else if (IS_LC2(lb))
-		{
-			*to++ = lb;
-			*to++ = (*from >> 8) & 0xff;
-			*to++ = *from & 0xff;
-			cnt += 3;
-		}
-		else if (IS_LCPRV1_A_RANGE(lb))
-		{
-			*to++ = LCPRV1_A;
-			*to++ = lb;
-			*to++ = *from & 0xff;
-			cnt += 3;
-		}
-		else if (IS_LCPRV1_B_RANGE(lb))
-		{
-			*to++ = LCPRV1_B;
-			*to++ = lb;
-			*to++ = *from & 0xff;
-			cnt += 3;
-		}
-		else if (IS_LCPRV2_A_RANGE(lb))
-		{
-			*to++ = LCPRV2_A;
-			*to++ = lb;
-			*to++ = (*from >> 8) & 0xff;
-			*to++ = *from & 0xff;
-			cnt += 4;
-		}
-		else if (IS_LCPRV2_B_RANGE(lb))
-		{
-			*to++ = LCPRV2_B;
-			*to++ = lb;
-			*to++ = (*from >> 8) & 0xff;
-			*to++ = *from & 0xff;
-			cnt += 4;
-		}
-		else
-		{
-			*to++ = *from & 0xff;
-			cnt += 1;
-		}
-		from++;
-		len--;
-	}
-	*to = 0;
-	return cnt;
-}
-
-/* exported for direct use by conv.c */
-int
-pg_mule_mblen(const unsigned char *s)
-{
-	int			len;
-
-	if (IS_LC1(*s))
-		len = 2;
-	else if (IS_LCPRV1(*s))
-		len = 3;
-	else if (IS_LC2(*s))
-		len = 3;
-	else if (IS_LCPRV2(*s))
-		len = 4;
-	else
-		len = 1;				/* assume ASCII */
-	return len;
-}
-
-static int
-pg_mule_dsplen(const unsigned char *s)
-{
-	int			len;
-
-	/*
-	 * Note: it's not really appropriate to assume that all multibyte charsets
-	 * are double-wide on screen.  But this seems an okay approximation for
-	 * the MULE charsets we currently support.
-	 */
-
-	if (IS_LC1(*s))
-		len = 1;
-	else if (IS_LCPRV1(*s))
-		len = 1;
-	else if (IS_LC2(*s))
-		len = 2;
-	else if (IS_LCPRV2(*s))
-		len = 2;
-	else
-		len = 1;				/* assume ASCII */
-
-	return len;
-}
-
 /*
  * ISO8859-1
  */
@@ -1378,56 +1206,6 @@ pg_johab_verifystr(const unsigned char *s, int len)
 	return s - start;
 }
 
-static int
-pg_mule_verifychar(const unsigned char *s, int len)
-{
-	int			l,
-				mbl;
-	unsigned char c;
-
-	l = mbl = pg_mule_mblen(s);
-
-	if (len < l)
-		return -1;
-
-	while (--l > 0)
-	{
-		c = *++s;
-		if (!IS_HIGHBIT_SET(c))
-			return -1;
-	}
-	return mbl;
-}
-
-static int
-pg_mule_verifystr(const unsigned char *s, int len)
-{
-	const unsigned char *start = s;
-
-	while (len > 0)
-	{
-		int			l;
-
-		/* fast path for ASCII-subset characters */
-		if (!IS_HIGHBIT_SET(*s))
-		{
-			if (*s == '\0')
-				break;
-			l = 1;
-		}
-		else
-		{
-			l = pg_mule_verifychar(s, len);
-			if (l == -1)
-				break;
-		}
-		s += l;
-		len -= l;
-	}
-
-	return s - start;
-}
-
 static int
 pg_latin1_verifychar(const unsigned char *s, int len)
 {
@@ -2091,7 +1869,6 @@ const pg_wchar_tbl pg_wchar_table[] = {
 	[PG_EUC_TW] = {pg_euctw2wchar_with_len, pg_wchar2euc_with_len, pg_euctw_mblen, pg_euctw_dsplen, pg_euctw_verifychar, pg_euctw_verifystr, 4},
 	[PG_EUC_JIS_2004] = {pg_eucjp2wchar_with_len, pg_wchar2euc_with_len, pg_eucjp_mblen, pg_eucjp_dsplen, pg_eucjp_verifychar, pg_eucjp_verifystr, 3},
 	[PG_UTF8] = {pg_utf2wchar_with_len, pg_wchar2utf_with_len, pg_utf_mblen, pg_utf_dsplen, pg_utf8_verifychar, pg_utf8_verifystr, 4},
-	[PG_MULE_INTERNAL] = {pg_mule2wchar_with_len, pg_wchar2mule_with_len, pg_mule_mblen, pg_mule_dsplen, pg_mule_verifychar, pg_mule_verifystr, 4},
 	[PG_LATIN1] = {pg_latin12wchar_with_len, pg_wchar2single_with_len, pg_latin1_mblen, pg_latin1_dsplen, pg_latin1_verifychar, pg_latin1_verifystr, 1},
 	[PG_LATIN2] = {pg_latin12wchar_with_len, pg_wchar2single_with_len, pg_latin1_mblen, pg_latin1_dsplen, pg_latin1_verifychar, pg_latin1_verifystr, 1},
 	[PG_LATIN3] = {pg_latin12wchar_with_len, pg_wchar2single_with_len, pg_latin1_mblen, pg_latin1_dsplen, pg_latin1_verifychar, pg_latin1_verifystr, 1},
diff --git a/src/include/mb/pg_wchar.h b/src/include/mb/pg_wchar.h
index e1655fe61d6..deee2a832c3 100644
--- a/src/include/mb/pg_wchar.h
+++ b/src/include/mb/pg_wchar.h
@@ -39,187 +39,21 @@ typedef unsigned int pg_wchar;
 #define SS3 0x8f				/* single shift 3 (JIS0212) */
 
 /*
- * SJIS validation macros
+ * EUC_TW planes
  */
-#define ISSJISHEAD(c) (((c) >= 0x81 && (c) <= 0x9f) || ((c) >= 0xe0 && (c) <= 0xfc))
-#define ISSJISTAIL(c) (((c) >= 0x40 && (c) <= 0x7e) || ((c) >= 0x80 && (c) <= 0xfc))
-
-/*----------------------------------------------------
- * MULE Internal Encoding (MIC)
- *
- * This encoding follows the design used within XEmacs; it is meant to
- * subsume many externally-defined character sets.  Each character includes
- * identification of the character set it belongs to, so the encoding is
- * general but somewhat bulky.
- *
- * Currently PostgreSQL supports 5 types of MULE character sets:
- *
- * 1) 1-byte ASCII characters.  Each byte is below 0x80.
- *
- * 2) "Official" single byte charsets such as ISO-8859-1 (Latin1).
- *	  Each MULE character consists of 2 bytes: LC1 + C1, where LC1 is
- *	  an identifier for the charset (in the range 0x81 to 0x8d) and C1
- *	  is the character code (in the range 0xa0 to 0xff).
- *
- * 3) "Private" single byte charsets such as SISHENG.  Each MULE
- *	  character consists of 3 bytes: LCPRV1 + LC12 + C1, where LCPRV1
- *	  is a private-charset flag, LC12 is an identifier for the charset,
- *	  and C1 is the character code (in the range 0xa0 to 0xff).
- *	  LCPRV1 is either 0x9a (if LC12 is in the range 0xa0 to 0xdf)
- *	  or 0x9b (if LC12 is in the range 0xe0 to 0xef).
- *
- * 4) "Official" multibyte charsets such as JIS X0208.  Each MULE
- *	  character consists of 3 bytes: LC2 + C1 + C2, where LC2 is
- *	  an identifier for the charset (in the range 0x90 to 0x99) and C1
- *	  and C2 form the character code (each in the range 0xa0 to 0xff).
- *
- * 5) "Private" multibyte charsets such as CNS 11643-1992 Plane 3.
- *	  Each MULE character consists of 4 bytes: LCPRV2 + LC22 + C1 + C2,
- *	  where LCPRV2 is a private-charset flag, LC22 is an identifier for
- *	  the charset, and C1 and C2 form the character code (each in the range
- *	  0xa0 to 0xff).  LCPRV2 is either 0x9c (if LC22 is in the range 0xf0
- *	  to 0xf4) or 0x9d (if LC22 is in the range 0xf5 to 0xfe).
- *
- * "Official" encodings are those that have been assigned code numbers by
- * the XEmacs project; "private" encodings have Postgres-specific charset
- * identifiers.
- *
- * See the "XEmacs Internals Manual", available at http://www.xemacs.org,
- * for more details.  Note that for historical reasons, Postgres'
- * private-charset flag values do not match what XEmacs says they should be,
- * so this isn't really exactly MULE (not that private charsets would be
- * interoperable anyway).
- *
- * Note that XEmacs's implementation is different from what emacs does.
- * We follow emacs's implementation, rather than XEmacs's.
- *----------------------------------------------------
- */
-
-/*
- * Charset identifiers (also called "leading bytes" in the MULE documentation)
- */
-
-/*
- * Charset IDs for official single byte encodings (0x81-0x8e)
- */
-#define LC_ISO8859_1		0x81	/* ISO8859 Latin 1 */
-#define LC_ISO8859_2		0x82	/* ISO8859 Latin 2 */
-#define LC_ISO8859_3		0x83	/* ISO8859 Latin 3 */
-#define LC_ISO8859_4		0x84	/* ISO8859 Latin 4 */
-#define LC_TIS620			0x85	/* Thai (not supported yet) */
-#define LC_ISO8859_7		0x86	/* Greek (not supported yet) */
-#define LC_ISO8859_6		0x87	/* Arabic (not supported yet) */
-#define LC_ISO8859_8		0x88	/* Hebrew (not supported yet) */
-#define LC_JISX0201K		0x89	/* Japanese 1 byte kana */
-#define LC_JISX0201R		0x8a	/* Japanese 1 byte Roman */
-/* Note that 0x8b seems to be unused as of Emacs 20.7.
- * However, there might be a chance that 0x8b could be used
- * in later versions of Emacs.
- */
-#define LC_KOI8_R			0x8b	/* Cyrillic KOI8-R */
-#define LC_ISO8859_5		0x8c	/* ISO8859 Cyrillic */
-#define LC_ISO8859_9		0x8d	/* ISO8859 Latin 5 (not supported yet) */
-#define LC_ISO8859_15		0x8e	/* ISO8859 Latin 15 (not supported yet) */
-/* #define CONTROL_1		0x8f	control characters (unused) */
-
-/* Is a leading byte for "official" single byte encodings? */
-#define IS_LC1(c)	((unsigned char)(c) >= 0x81 && (unsigned char)(c) <= 0x8d)
-
-/*
- * Charset IDs for official multibyte encodings (0x90-0x99)
- * 0x9a-0x9d are free. 0x9e and 0x9f are reserved.
- */
-#define LC_JISX0208_1978	0x90	/* Japanese Kanji, old JIS (not supported) */
-#define LC_GB2312_80		0x91	/* Chinese */
-#define LC_JISX0208			0x92	/* Japanese Kanji (JIS X 0208) */
-#define LC_KS5601			0x93	/* Korean */
-#define LC_JISX0212			0x94	/* Japanese Kanji (JIS X 0212) */
 #define LC_CNS11643_1		0x95	/* CNS 11643-1992 Plane 1 */
 #define LC_CNS11643_2		0x96	/* CNS 11643-1992 Plane 2 */
-#define LC_JISX0213_1		0x97	/* Japanese Kanji (JIS X 0213 Plane 1)
-									 * (not supported) */
-#define LC_BIG5_1			0x98	/* Plane 1 Chinese traditional (not
-									 * supported) */
-#define LC_BIG5_2			0x99	/* Plane 1 Chinese traditional (not
-									 * supported) */
-
-/* Is a leading byte for "official" multibyte encodings? */
-#define IS_LC2(c)	((unsigned char)(c) >= 0x90 && (unsigned char)(c) <= 0x99)
-
-/*
- * Postgres-specific prefix bytes for "private" single byte encodings
- * (According to the MULE docs, we should be using 0x9e for this)
- */
-#define LCPRV1_A		0x9a
-#define LCPRV1_B		0x9b
-#define IS_LCPRV1(c)	((unsigned char)(c) == LCPRV1_A || (unsigned char)(c) == LCPRV1_B)
-#define IS_LCPRV1_A_RANGE(c)	\
-	((unsigned char)(c) >= 0xa0 && (unsigned char)(c) <= 0xdf)
-#define IS_LCPRV1_B_RANGE(c)	\
-	((unsigned char)(c) >= 0xe0 && (unsigned char)(c) <= 0xef)
-
-/*
- * Postgres-specific prefix bytes for "private" multibyte encodings
- * (According to the MULE docs, we should be using 0x9f for this)
- */
-#define LCPRV2_A		0x9c
-#define LCPRV2_B		0x9d
-#define IS_LCPRV2(c)	((unsigned char)(c) == LCPRV2_A || (unsigned char)(c) == LCPRV2_B)
-#define IS_LCPRV2_A_RANGE(c)	\
-	((unsigned char)(c) >= 0xf0 && (unsigned char)(c) <= 0xf4)
-#define IS_LCPRV2_B_RANGE(c)	\
-	((unsigned char)(c) >= 0xf5 && (unsigned char)(c) <= 0xfe)
-
-/*
- * Charset IDs for private single byte encodings (0xa0-0xef)
- */
-#define LC_SISHENG			0xa0	/* Chinese SiSheng characters for
-									 * PinYin/ZhuYin (not supported) */
-#define LC_IPA				0xa1	/* IPA (International Phonetic
-									 * Association) (not supported) */
-#define LC_VISCII_LOWER		0xa2	/* Vietnamese VISCII1.1 lower-case (not
-									 * supported) */
-#define LC_VISCII_UPPER		0xa3	/* Vietnamese VISCII1.1 upper-case (not
-									 * supported) */
-#define LC_ARABIC_DIGIT		0xa4	/* Arabic digit (not supported) */
-#define LC_ARABIC_1_COLUMN	0xa5	/* Arabic 1-column (not supported) */
-#define LC_ASCII_RIGHT_TO_LEFT	0xa6	/* ASCII (left half of ISO8859-1) with
-										 * right-to-left direction (not
-										 * supported) */
-#define LC_LAO				0xa7	/* Lao characters (ISO10646 0E80..0EDF)
-									 * (not supported) */
-#define LC_ARABIC_2_COLUMN	0xa8	/* Arabic 1-column (not supported) */
-
-/*
- * Charset IDs for private multibyte encodings (0xf0-0xff)
- */
-#define LC_INDIAN_1_COLUMN	0xf0	/* Indian charset for 1-column width
-									 * glyphs (not supported) */
-#define LC_TIBETAN_1_COLUMN 0xf1	/* Tibetan 1-column width glyphs (not
-									 * supported) */
-#define LC_UNICODE_SUBSET_2 0xf2	/* Unicode characters of the range
-									 * U+2500..U+33FF. (not supported) */
-#define LC_UNICODE_SUBSET_3 0xf3	/* Unicode characters of the range
-									 * U+E000..U+FFFF. (not supported) */
-#define LC_UNICODE_SUBSET	0xf4	/* Unicode characters of the range
-									 * U+0100..U+24FF. (not supported) */
-#define LC_ETHIOPIC			0xf5	/* Ethiopic characters (not supported) */
 #define LC_CNS11643_3		0xf6	/* CNS 11643-1992 Plane 3 */
 #define LC_CNS11643_4		0xf7	/* CNS 11643-1992 Plane 4 */
 #define LC_CNS11643_5		0xf8	/* CNS 11643-1992 Plane 5 */
 #define LC_CNS11643_6		0xf9	/* CNS 11643-1992 Plane 6 */
 #define LC_CNS11643_7		0xfa	/* CNS 11643-1992 Plane 7 */
-#define LC_INDIAN_2_COLUMN	0xfb	/* Indian charset for 2-column width
-									 * glyphs (not supported) */
-#define LC_TIBETAN			0xfc	/* Tibetan (not supported) */
-/* #define FREE				0xfd	free (unused) */
-/* #define FREE				0xfe	free (unused) */
-/* #define FREE				0xff	free (unused) */
-
-/*----------------------------------------------------
- * end of MULE stuff
- *----------------------------------------------------
+
+/*
+ * SJIS validation macros
  */
+#define ISSJISHEAD(c) (((c) >= 0x81 && (c) <= 0x9f) || ((c) >= 0xe0 && (c) <= 0xfc))
+#define ISSJISTAIL(c) (((c) >= 0x40 && (c) <= 0x7e) || ((c) >= 0x80 && (c) <= 0xfc))
 
 /*
  * PostgreSQL encoding identifiers
@@ -246,7 +80,7 @@ typedef enum pg_enc
 	PG_EUC_TW,					/* EUC for Taiwan */
 	PG_EUC_JIS_2004,			/* EUC-JIS-2004 */
 	PG_UTF8,					/* Unicode UTF8 */
-	PG_MULE_INTERNAL,			/* Mule internal code */
+	PG_UNUSED_1,				/* (Was Mule internal code) */
 	PG_LATIN1,					/* ISO-8859-1 Latin 1 */
 	PG_LATIN2,					/* ISO-8859-2 Latin 2 */
 	PG_LATIN3,					/* ISO-8859-3 Latin 3 */
@@ -290,18 +124,21 @@ typedef enum pg_enc
 
 #define PG_ENCODING_BE_LAST PG_KOI8U
 
+#define PG_UNUSED_ENCODING(_enc) \
+	((_enc) == PG_UNUSED_1)
+
 /*
  * Please use these tests before access to pg_enc2name_tbl[]
  * or to other places...
  */
 #define PG_VALID_BE_ENCODING(_enc) \
-		((_enc) >= 0 && (_enc) <= PG_ENCODING_BE_LAST)
+		((_enc) >= 0 && (_enc) <= PG_ENCODING_BE_LAST && !PG_UNUSED_ENCODING(_enc))
 
 #define PG_ENCODING_IS_CLIENT_ONLY(_enc) \
 		((_enc) > PG_ENCODING_BE_LAST && (_enc) < _PG_LAST_ENCODING_)
 
 #define PG_VALID_ENCODING(_enc) \
-		((_enc) >= 0 && (_enc) < _PG_LAST_ENCODING_)
+		((_enc) >= 0 && (_enc) < _PG_LAST_ENCODING_ && !PG_UNUSED_ENCODING(_enc))
 
 /* On FE are possible all encodings */
 #define PG_VALID_FE_ENCODING(_enc)	PG_VALID_ENCODING(_enc)
@@ -678,7 +515,6 @@ extern const char *get_encoding_name_for_icu(int encoding);
 
 extern bool pg_utf8_islegal(const unsigned char *source, int length);
 extern int	pg_utf_mblen(const unsigned char *s);
-extern int	pg_mule_mblen(const unsigned char *s);
 
 /*
  * The remaining functions are backend-only.
@@ -782,16 +618,6 @@ pg_noreturn extern void report_untranslatable_char(int src_encoding, int dest_en
 extern int	local2local(const unsigned char *l, unsigned char *p, int len,
 						int src_encoding, int dest_encoding,
 						const unsigned char *tab, bool noError);
-extern int	latin2mic(const unsigned char *l, unsigned char *p, int len,
-					  int lc, int encoding, bool noError);
-extern int	mic2latin(const unsigned char *mic, unsigned char *p, int len,
-					  int lc, int encoding, bool noError);
-extern int	latin2mic_with_table(const unsigned char *l, unsigned char *p,
-								 int len, int lc, int encoding,
-								 const unsigned char *tab, bool noError);
-extern int	mic2latin_with_table(const unsigned char *mic, unsigned char *p,
-								 int len, int lc, int encoding,
-								 const unsigned char *tab, bool noError);
 
 #ifdef WIN32
 extern WCHAR *pgwin32_message_to_UTF16(const char *str, int len, int *utf16len);
diff --git a/src/pl/plpython/plpy_util.c b/src/pl/plpython/plpy_util.c
index ef710aa371e..c2338decba2 100644
--- a/src/pl/plpython/plpy_util.c
+++ b/src/pl/plpython/plpy_util.c
@@ -40,8 +40,8 @@ PLyUnicode_Bytes(PyObject *unicode)
 	 *
 	 * PyUnicode_AsEncodedString could be used to encode the object directly
 	 * in the server encoding, but Python doesn't support all the encodings
-	 * that PostgreSQL does (EUC_TW and MULE_INTERNAL). UTF-8 is used as an
-	 * intermediary in PLyUnicode_FromString as well.
+	 * that PostgreSQL does (EUC_TW). UTF-8 is used as an intermediary in
+	 * PLyUnicode_FromString as well.
 	 */
 	if (GetDatabaseEncoding() != PG_UTF8)
 	{
diff --git a/src/test/mb/mbregress.sh b/src/test/mb/mbregress.sh
index c313565fb4b..b650b31074f 100755
--- a/src/test/mb/mbregress.sh
+++ b/src/test/mb/mbregress.sh
@@ -21,7 +21,7 @@ PSQL="psql -X -n -e -q"
 
 # in the test list, client-only encodings must follow the server encoding
 # they're to be tested with; see hard-coded cases below
-tests="euc_jp sjis euc_kr euc_cn euc_tw big5 utf8 gb18030 mule_internal"
+tests="euc_jp sjis euc_kr euc_cn euc_tw big5 utf8 gb18030"
 
 EXITCODE=0
 
diff --git a/src/test/modules/test_escape/test_escape.c b/src/test/modules/test_escape/test_escape.c
index 1606b5a46b5..6dab4f2cf5b 100644
--- a/src/test/modules/test_escape/test_escape.c
+++ b/src/test/modules/test_escape/test_escape.c
@@ -526,8 +526,6 @@ static pe_test_vector pe_test_vectors[] =
 	TV("gbk", "\x80\""),
 	TV("gbk", "\x80\\"),
 
-	TV("mule_internal", "\\\x9c';\0;"),
-
 	TV("sql_ascii", "1\xC0'"),
 
 	/*
diff --git a/src/test/regress/regress.c b/src/test/regress/regress.c
index 96cf30ac925..0237eeadf15 100644
--- a/src/test/regress/regress.c
+++ b/src/test/regress/regress.c
@@ -949,6 +949,8 @@ test_enc_setup(PG_FUNCTION_ARGS)
 					mblen,
 					valid;
 
+		if (!PG_VALID_ENCODING(i))
+			continue;
 		if (pg_encoding_max_length(i) == 1)
 			continue;
 		pg_encoding_set_invalid(i, buf);
diff --git a/src/test/regress/sql/conversion.sql b/src/test/regress/sql/conversion.sql
index 83d7105ac1e..c9a76cb014f 100644
--- a/src/test/regress/sql/conversion.sql
+++ b/src/test/regress/sql/conversion.sql
@@ -329,7 +329,6 @@ select description, inbytes, (test_conv(inbytes, 'iso8859-5', 'iso8859-5')).* fr
 -- Test conversions from ISO-8859-5
 select description, inbytes, (test_conv(inbytes, 'iso8859-5', 'utf8')).* from iso8859_5_inputs;
 select description, inbytes, (test_conv(inbytes, 'iso8859-5', 'koi8r')).* from iso8859_5_inputs;
-select description, inbytes, (test_conv(inbytes, 'iso8859_5', 'mule_internal')).* from iso8859_5_inputs;
 
 --
 -- Big5
@@ -346,29 +345,3 @@ insert into big5_inputs  values
 select description, inbytes, (test_conv(inbytes, 'big5', 'big5')).* from big5_inputs;
 -- Test conversions from Big5
 select description, inbytes, (test_conv(inbytes, 'big5', 'utf8')).* from big5_inputs;
-select description, inbytes, (test_conv(inbytes, 'big5', 'mule_internal')).* from big5_inputs;
-
---
--- MULE_INTERNAL
---
-CREATE TABLE mic_inputs (inbytes bytea, description text);
-insert into mic_inputs  values
-  ('\x666f6f',		'valid, pure ASCII'),
-  ('\x8bc68bcf8bcf',	'valid (in KOI8R)'),
-  ('\x8bc68bcf8b',	'invalid,incomplete char'),
-  ('\x92bedd',		'valid (in SHIFT_JIS)'),
-  ('\x92be',		'invalid, incomplete char)'),
-  ('\x666f6f95a3c1',	'valid (in Big5)'),
-  ('\x666f6f95a3',	'invalid, incomplete char'),
-  ('\x9200bedd',	'invalid, NUL byte'),
-  ('\x92bedd00',	'invalid, NUL byte'),
-  ('\x8b00c68bcf8bcf',	'invalid, NUL byte');
-
--- Test MULE_INTERNAL verification
-select description, inbytes, (test_conv(inbytes, 'mule_internal', 'mule_internal')).* from mic_inputs;
--- Test conversions from MULE_INTERNAL
-select description, inbytes, (test_conv(inbytes, 'mule_internal', 'koi8r')).* from mic_inputs;
-select description, inbytes, (test_conv(inbytes, 'mule_internal', 'iso8859-5')).* from mic_inputs;
-select description, inbytes, (test_conv(inbytes, 'mule_internal', 'sjis')).* from mic_inputs;
-select description, inbytes, (test_conv(inbytes, 'mule_internal', 'big5')).* from mic_inputs;
-select description, inbytes, (test_conv(inbytes, 'mule_internal', 'euc_jp')).* from mic_inputs;
diff --git a/src/test/regress/sql/encoding.sql b/src/test/regress/sql/encoding.sql
index b9543c0cb32..5e1fcb67a71 100644
--- a/src/test/regress/sql/encoding.sql
+++ b/src/test/regress/sql/encoding.sql
@@ -198,16 +198,7 @@ INSERT INTO encoding_tests VALUES
 	('UTF8',   '6 byte, unsupported', '\xfd8283'),
 	('UTF8',   '6 byte, unsupported', '\xfd828384'),
 	('UTF8',   '6 byte, unsupported', '\xfd82838485'),
-	('UTF8',   '6 byte, unsupported', '\xfd8283848586'),
-	-- MULE_INTERNAL
-	-- 2 81..8d LC1
-	-- 3 90..99 LC2
-	('MULE_INTERNAL', 'ASCII',         'a'),
-	('MULE_INTERNAL', 'LC1, short',    '\x81'),
-	('MULE_INTERNAL', 'LC1',           '\x8182'),
-	('MULE_INTERNAL', 'LC2, short',    '\x90'),
-	('MULE_INTERNAL', 'LC2, short',    '\x9082'),
-	('MULE_INTERNAL', 'LC2',           '\x908283');
+	('UTF8',   '6 byte, unsupported', '\xfd8283848586');
 
 SELECT COUNT(test_encoding(encoding, description, input)) > 0
 FROM encoding_tests;
diff --git a/src/test/regress/sql/object_address.sql b/src/test/regress/sql/object_address.sql
index 1a6c61f49d5..25d21c83145 100644
--- a/src/test/regress/sql/object_address.sql
+++ b/src/test/regress/sql/object_address.sql
@@ -176,7 +176,7 @@ WITH objects (type, name, args) AS (VALUES
     ('collation', '{default}', '{}'),
     ('table constraint', '{addr_nsp, gentable, a_chk}', '{}'),
     ('domain constraint', '{addr_nsp.gendomain}', '{domconstr}'),
-    ('conversion', '{pg_catalog, koi8_r_to_mic}', '{}'),
+    ('conversion', '{pg_catalog, koi8_r_to_utf8}', '{}'),
     ('default value', '{addr_nsp, gentable, b}', '{}'),
     ('language', '{plpgsql}', '{}'),
     -- large object
diff --git a/src/test/regress/sql/xml.sql b/src/test/regress/sql/xml.sql
index 0ea4f508837..a771a441c36 100644
--- a/src/test/regress/sql/xml.sql
+++ b/src/test/regress/sql/xml.sql
@@ -272,9 +272,7 @@ BEGIN
   END IF;
 EXCEPTION
   -- character with byte sequence 0xc2 0xb0 in encoding "UTF8" has no equivalent in encoding "LATIN8"
-  WHEN untranslatable_character
-  -- default conversion function for encoding "UTF8" to "MULE_INTERNAL" does not exist
-  OR undefined_function
+  WHEN undefined_function
   -- unsupported XML feature
   OR feature_not_supported THEN
     RAISE LOG 'skip: %', SQLERRM;
-- 
2.50.1 (Apple Git-155)

